///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//
// This file is part of CG-seq.
//
//  CG-seq is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  CG-seq is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with CG-seq.  If not, see <http://www.gnu.org/licenses/>.
//
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JOptionPane;


//Class that will manage software configuration
public class Configure_sequences_button_listener implements ActionListener{


    //Main window
    private Main_window main_window;

    //Sequences configuration window
    private Configuration_sequences_window conf_seq_window = null;


    //Constructor
    public Configure_sequences_button_listener(Main_window main_window){

	super();
	this.main_window = main_window;
	
    }


    public void actionPerformed(ActionEvent e){

	if(!((main_window.get_others_text()).equals(""))){
	    conf_seq_window = new Configuration_sequences_window(main_window);
	    //Create the dialog window
	    conf_seq_window.build();

	}
	else{

	    //Error dialog
	    JOptionPane error_pane = new JOptionPane();
	    error_pane.showMessageDialog(main_window,
					 "You must provide at least one other species",
					 "ERROR : other species missing...",
					 JOptionPane.ERROR_MESSAGE);


	}
    
    }

}
