///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//
// This file is part of CG-seq.
//
//  CG-seq is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  CG-seq is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with CG-seq.  If not, see <http://www.gnu.org/licenses/>.
//
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JOptionPane;


//Class that will manage software configuration
public class Configure_software_button_listener implements ActionListener{


    //Main window
    private Main_window main_window;

    //Sequences configuration window
    private Configuration_software_main_window conf_soft_main_window = null;

    //Software checked by user
    private String[] software;



    //Constructor
    public Configure_software_button_listener(Main_window main_window){

	super();
	this.main_window = main_window;


    }


    public void actionPerformed(ActionEvent e){

	//Recuperate number of selected software
	int nb_software = main_window.get_software_number();

	if(main_window.mask_regions_wanted()){
		nb_software--;
	}

	if(nb_software != 0){

	    int current_index = 0;
	    //Recuperate selected software
	    software = new String[nb_software];

	    if(main_window.mask_redundancy_wanted()){
		software[current_index] = "clean up redundancy";
		current_index++;
	    }
	    if(main_window.yass_wanted()){
		software[current_index] = "yass";
		current_index++;
	    }
	    if(main_window.blast_wanted()){
		software[current_index] = "blast";
		current_index++;
	    }
	    if(main_window.conserved_wanted()){
		software[current_index] = "conserved regions";
		current_index++;
	    }
	    if(main_window.carnac_wanted()){
		software[current_index] = "carnac";
		current_index++;
	    }
	    if(main_window.rnaz_wanted()){
		software[current_index] = "rnaz";
		current_index++;
	    }

	    //Create the dialog window
	    conf_soft_main_window = 
		new Configuration_software_main_window(main_window,
						       software);
	    conf_soft_main_window.build();

	}

	else{

	    //Error dialog
	    JOptionPane error_pane = new JOptionPane();
	    error_pane.showMessageDialog(main_window,
					 "Select at least one software that is configurable",
					 "ERROR : no configurable software selected...",
					 JOptionPane.ERROR_MESSAGE);

	}
    
    }

}
