///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//
// This file is part of CG-seq.
//
//  CG-seq is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  CG-seq is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with CG-seq.  If not, see <http://www.gnu.org/licenses/>.
//
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


import java.awt.event.FocusListener;
import java.awt.event.FocusEvent;
import javax.swing.JTextField;


//Class that will launch actions on textfields when focus is off
//to 
public class Focus_listener implements FocusListener{


    //Software window that contains the textfield
    Configuration_software_window soft_window = null;

    //Index in the array of parameters linked with the textfield
    int index;

    //Boolean that says if the value must be prefixed and suffixed by """
    boolean has_quote;

    //Constructor
    Focus_listener(Configuration_software_window soft_window, 
		   int index,
		   boolean has_quote){

	super();
	this.soft_window = soft_window;
	this.index = index;
	this.has_quote = has_quote;
    } 



    //Do nothing when focus is gained
    public void focusGained(FocusEvent e) {
        
    }
    

    //Update the parameters array when focus is lost
    public void focusLost(FocusEvent e) {
	


	//Get the index to update parameters array
	JTextField textfield = (JTextField)e.getSource();

	String value = textfield.getText();
	if(has_quote){
	    value = "\""+value+"\"";
	}


	soft_window.update_parameters(index,value);

        
    }
    












}