///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//
// This file is part of CG-seq.
//
//  CG-seq is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  CG-seq is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with CG-seq.  If not, see <http://www.gnu.org/licenses/>.
//
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.text.JTextComponent;
import javax.swing.JFileChooser;
import java.io.File;


//Class that will manage open actions
public class Open_button_listener implements ActionListener{


    //Open mode : files and/or directories only
    private int mode;

    //Textfield that will print the selected files and/or directories
    private JTextComponent text_field = null;

    //Multiselection enable or not
    private boolean multiselection;

    //File chooser
    private JFileChooser file_chooser = null;

    // Last open directory
    private static File last_open = null;

    //Constructor
    public Open_button_listener(JTextComponent text, int mode, boolean multi){

	super();
	this.text_field = text;
	this.mode = mode;
	this.multiselection = multi;
    } 

    public void actionPerformed(ActionEvent e){

	//Create the file chooser
	file_chooser = new JFileChooser(last_open);
	file_chooser.setFileSelectionMode(mode);
	file_chooser.setMultiSelectionEnabled(multiselection);

	//Show dialog and set the textfield with the selected ones
	if(file_chooser.showOpenDialog(null) == JFileChooser.APPROVE_OPTION){

	    String selected = "";

	    last_open = file_chooser.getSelectedFile();

	    //Single file selection mode
	    if(!multiselection){
		selected = file_chooser.getSelectedFile().toString();
	    }
	    //Multi selection
	    else{

		if(!(text_field.getText().equals(""))){
		    selected = text_field.getText()+",\n";
		}

		File[] selected_files = file_chooser.getSelectedFiles();
		for(int i = 0; i < selected_files.length - 1; i++){
		    selected += selected_files[i].toString()+",\n";
		}
		selected += 
		    selected_files[selected_files.length - 1].toString();
		

	    }


	    //Set the textfield with the updated text
	    text_field.setText(selected);



	}



    }





}