/*
 *  YASS 1.12
 *  Copyright (C) 2004-2007
 *  YASS Team
 *  Laurent Noe, Gregory Kucherov, Mikhail Roytberg, 
 *  Steven Corroy, Christophe Valmir.
 *
 *  laurent.noe|<A>|lifl.fr
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the CeCILL License as published by
 *  the CEA-CNRS-INRIA; either version 2 of the License, or (at your
 *  option) any later version, and the GNU General Public License as
 *  published by the Free Software Foundation; either version 3 of the
 *  License, or (at your option) any later version.
 *
 *  This software contains code derived from the GNU libavl library.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef __KWORD_H_
#define __KWORD_H_

#include "threads.h"

#define KEY(keyvalue,data,pos,seed) {                           \
    int  _i_ = 0;                                               \
    keyvalue = 0;                                               \
    for ( _i_ = 0 ; _i_ < gp_seeds_span[seed] ; _i_++ ){        \
        unsigned _data_element_ = (int)(data[(pos)+_i_]);       \
        char     _seed_element_ = gp_motifs[seed][_i_];         \
	if  (unindexable[_data_element_]) {                     \
	    keyvalue =  -1;                                     \
	    break;                                              \
	}                                                       \
        switch (_seed_element_) {                               \
           case '#' :                                           \
	      keyvalue <<= 2;                                   \
	      keyvalue  |= (backcode[_data_element_]);          \
	   break;                                               \
	   case '@' :                                           \
              keyvalue <<= 1;                                   \
	      keyvalue  |= (backcode[_data_element_]&0x1);      \
           break;                                               \
	}                                                       \
    }                                                           \
}


/* Read multifasta sequence */
int CreateData(/* in */  char *filename,
	       /* out */ char **p_data,     /* out */ int *p_datasize, 
	       /* out */ int *p_nbchunks,   /* out */ char ***p_chunkname, 
	       /* out */ int **p_chunksize, /* out */ int **p_chunkstart,
	       /* out */ int * nbletters  /* [4]  */ , 
	       /* out */ int * nbtriplets /* [64] */ );

/* Sequence reverse complement */
int CreateReverseComplement( /*in */ char *data_in,
			    /*out */ int datasize,
			    /*out */ char **p_data_out);
/* Build the Index */
int CreateKeyList( /* in */  char *data,    /* in  */ int   datasize,    /* in */ int seed,
		   /* out */ int **p_first, /* out */ int * p_first_size, 
		   /* out */ int **p_list,  /* out */ int * p_list_size, /* out */ Feature * feature);

int ComputeLengthAndSortSeeds();

void AutomataOverlaps(int delph);

double Entropy(char *data, int pos, int len, int k);

/* Debugging */
int DisplaySequence(char *data, int pos, int len);
int DisplayQuery();
int DisplayText();

int DisplayData(char * filename, char * data, int size, int nbchunks, char ** chunkname, int * chunksize, int * chunkstrt);

int DisplaySeeds();

#endif
