/*
 *  YASS 1.12
 *  Copyright (C) 2004-2007
 *  YASS Team
 *  Laurent Noe, Gregory Kucherov, Mikhail Roytberg, 
 *  Steven Corroy, Christophe Valmir.
 *
 *  laurent.noe|<A>|lifl.fr
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the CeCILL License as published by
 *  the CEA-CNRS-INRIA; either version 2 of the License, or (at your
 *  option) any later version, and the GNU General Public License as
 *  published by the Free Software Foundation; either version 3 of the
 *  License, or (at your option) any later version.
 *
 *  This software contains code derived from the GNU libavl library.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef __PROBA_H_
#define __PROBA_H_

int statistical_bound_of_waiting_time1(double p, int k, double alpha);
int statistical_bound_of_waiting_time2(double p, int k, double alpha);
double *randomwalk_probability_of_pos1(double pI, int L);
double *randomwalk_probability_of_pos2(double pI, int L);
double *randomwalk_probability_of_pos3(double pI, int L);
int statistical_bound_of_randomwalk1(double pI, int L, double alpha);
int statistical_bound_of_randomwalk2(double pI, int L, double alpha);
double Evalue(double K, double Lambda, int query_size, int text_size,
	      int score);
int MinScore(double K, double Lambda, int query_size, int text_size,
	     double MaxEvalue);
double BitScore(double K, double Lambda, int score);
double P_mutation_bias(int freq[]);

double ** computeLettersFrequency(int nb_letters[2][4]);
double ** computeBackgroundFrequency(double ** letters_frequency /* [2][4] */);
double ** computeBackgroundTripletFrequency(int nb_words[2][64]);

double computeLambda(double ** freq_letters /* [2][4] */);
double computeK(double ** freq_letters /* [2][4] */, double lambda);

double entropyTriplet(int * count /* [4^3]*/);
double mutualInformationTriplet(int ** count /* [4^3] x [4^3] */);

#endif
